SystemOrganization addCategory: #'Morphic-Graphs'!

PackageInfo subclass: #GraphMorphInfo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Graphs'!

!GraphMorphInfo methodsFor: 'as yet unclassified' stamp: 'Samir Saidani 9/17/2003 16:26'!
methodCategoryPrefix
	^ '*graph'! !

!GraphMorphInfo methodsFor: 'as yet unclassified' stamp: 'Samir Saidani 9/17/2003 16:24'!
prerequisitePackages
	"These are the names of DVS packages that get loaded before the main 
	change set"
	^ #('Collections-Graphs')! !

!GraphMorphInfo methodsFor: 'as yet unclassified' stamp: 'Samir Saidani 9/17/2003 18:23'!
prerequisiteChangeSets
	"These are the names of DVS packages that get loaded before the main  
	change set"
	^ #('Collections-Misc' 'Iterator' )! !

!GraphMorphInfo methodsFor: 'as yet unclassified' stamp: ''!
readmeText
	^ '
This is a new version of Collection-Graphs and Morphic-Graphs, more usable than
the previous one.

Try this..
Samir Saidani.

|layout|
layout_GraphLayoutMorph new openInWorld.
layout graph:(Graph exampleGraph ).
(layout graph) addNode: #k.
(layout graph) addEdge: #k -> #r2.
(layout graph) removeEdge: #r1 -> #n1.
layout clearAll.
layout redraw.
layout clearAll.
layout graph:(Graph exampleGraph3 ).
layout redraw.
(layout graph) addNode: #k.
(layout graph) addEdge: #k -> #r2.
(layout graph) removeEdge: #r1 -> #n1.



'! !

PasteUpMorph subclass: #GraphLayoutMorph
	instanceVariableNames: 'graph nodeToMorph edgeToMorph focusNode '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Graphs'!

!GraphLayoutMorph commentStamp: '<historical>' prior: 0!
My instances are Graphs that can be shown in a morphic world.

The graphical representation is achieved by thinking that each pair of nodes is connected
with a contractile or expansive spring, for connected or unconnected nodes, respectively.
This makes connected nodes stay close to each other, and unconnected nodes away.
[not finished yet]
Mis instancias son grafos que pueden ser vistos en un morphic world.

La representacion grafica es lograda pensando que cada par de nodos esta conectado con un resorte contractil o expansivo, dependiendo si los nodos estan conectados o desconectados.
Esto produce que los nodos conectados traten de mantenerse cerca unos de los otros, y que los
desconectados se alejen. [todavia no esta terminado]!

!GraphLayoutMorph methodsFor: 'accessing' stamp: 'len 2/12/2003 23:18'!
nodeClass
	^ GraphNodeMorph! !

!GraphLayoutMorph methodsFor: 'accessing' stamp: 'Samir Saidani 5/14/2003 17:35'!
graph
^graph! !

!GraphLayoutMorph methodsFor: 'layout' stamp: ''!
clearNodes
	nodeToMorph _ IdentityDictionary new.
	self removeAllMorphs.! !

!GraphLayoutMorph methodsFor: 'enumerating' stamp: 'len 2/15/2003 19:02'!
edgesDo: aBlock
	edgeToMorph do: aBlock! !

!GraphLayoutMorph methodsFor: 'private' stamp: ''!
addEdge: anEdge label: label 
	"If there is no nodes on the model, create it"
	| src dest |
	(self graph nodes includes: anEdge key)
		ifFalse: [self error: 'no nodes on the model'].
	(self graph nodes includes: anEdge value)
		ifFalse: [self error: 'no nodes on the model'].
	"transformation from symbol nodes to graph nodes"
	src _ self graph getNode: anEdge key.
	dest _ self graph getNode: anEdge value.
	^ self privateAddEdge: src -> dest label: label! !

!GraphLayoutMorph methodsFor: 'event handling' stamp: 'len 2/8/2003 00:38'!
allowSubmorphExtraction
	^ false! !

!GraphLayoutMorph methodsFor: 'layout' stamp: ''!
clearEdges
	self edgesDo: [ :edgeMorph | edgeMorph delete .].
	edgeToMorph _ Dictionary new! !

!GraphLayoutMorph methodsFor: 'event handling' stamp: 'len 2/12/2003 23:21'!
acceptDroppingMorph: aMorph event: evt
	(aMorph isKindOf: self nodeClass)
		ifTrue: [self addMorph: aMorph.
				self focusOn: aMorph node.
				^ self startStepping].
	^ super acceptDroppingMorph: aMorph event: evt! !

!GraphLayoutMorph methodsFor: 'accessing' stamp: 'len 2/18/2003 21:34'!
nodeToMorph
	^ nodeToMorph! !

!GraphLayoutMorph methodsFor: 'accessing' stamp: ''!
graph: aGraph 

	self removeAllMorphs.
	graph _ aGraph.
	aGraph
		nodesDo: [:each | self addNode: each].
	graph
		when: #addNode:
		send: #addNode:
		to: self.
	graph
		when: #addEdge:
		send: #addEdge:
		to: self.
	graph
		when: #removeNode:
		send: #removeNode:
		to: self.
	graph
		when: #removeEdge:
		send: #removeEdge:
		to: self.
	(graph isKindOf: RootedGraph)
		ifTrue: [self focusOn: graph rootNode]
		ifFalse: [self focusOn: graph anyOne]! !

!GraphLayoutMorph methodsFor: 'initialization' stamp: 'len 2/17/2003 23:11'!
initialize
	super initialize.
	self extent: 600@600.
	self color: Color veryVeryLightGray.
	self borderColor: Color lightGray.

	nodeToMorph _ IdentityDictionary new.
	edgeToMorph _ Dictionary new! !

!GraphLayoutMorph methodsFor: 'accessing' stamp: ''!
edgeClass
(self graph type) = #(#ordered)
ifTrue:[^ DirectedEdgeMorph] ifFalse: [^ EdgeMorph ]
! !

GraphLayoutMorph subclass: #RadialGraphMorph
	instanceVariableNames: 'queue layoutTree dijkstra '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Graphs'!

!RadialGraphMorph methodsFor: 'as yet unclassified' stamp: 'len 2/14/2003 23:41'!
graph: aGraph
	^ super graph: aGraph symmetric! !

!RadialGraphMorph methodsFor: 'as yet unclassified' stamp: 'len 2/9/2003 20:59'!
polarToCartesian: aPoint
	^ (Point r: aPoint x degrees: aPoint y) + self origin! !

!RadialGraphMorph methodsFor: 'as yet unclassified' stamp: 'len 2/12/2003 23:20'!
nodeClass
	^ RadialNodeMorph! !

!RadialGraphMorph methodsFor: 'as yet unclassified' stamp: 'len 2/11/2003 22:15'!
numberOfRings
	^ 8! !

!RadialGraphMorph methodsFor: 'as yet unclassified' stamp: 'len 2/15/2003 19:07'!
moveNode: aGraphNode radius: radius angle: angle width: width time: time
	| morph eachAngle neighbors angleFraction eachAngleWidth |
	(queue includes: aGraphNode) ifTrue: [^ self].
	queue add: aGraphNode.
	morph _ nodeToMorph at: aGraphNode.
	morph moveToRadius: radius angle: angle time: time.

	neighbors _ aGraphNode neighbors copyWithoutAll: queue.
	neighbors isEmpty ifTrue: [^ self].

	angleFraction _ width / neighbors size.
	eachAngle _ angle - (width/2).
	neighbors do: [:each |
		eachAngleWidth _ angleFraction.
		self moveNode: each
			radius: radius + self ringSeparation
			angle: eachAngle + (eachAngleWidth/2)
			width: eachAngleWidth
			time: time.
		eachAngle _ eachAngle + eachAngleWidth]! !

!RadialGraphMorph methodsFor: 'as yet unclassified' stamp: 'len 2/14/2003 23:15'!
focusOn: aGraphNode
	| angle |
	super focusOn: aGraphNode.
	queue _ Set new: graph size.
	angle _ (self cartesianToPolar: (nodeToMorph at: aGraphNode) center) y.
	layoutTree _ RootedGraph ordered.
	layoutTree roots: (Set with: aGraphNode).
	aGraphNode markDo: [:each | layoutTree add: each].
	self moveNode: aGraphNode radius: 0 angle: angle width: 360 time: 600! !

!RadialGraphMorph methodsFor: 'as yet unclassified' stamp: 'len 2/9/2003 22:43'!
drawOn: aCanvas
	| ringExtent ringColor |
	super drawOn: aCanvas.
"	ringExtent _ self ringSeparation @ self ringSeparation.
	ringColor _ color alphaMixed: 0.9 with: Color black.
	aCanvas clipBy: bounds during: [:tempCanvas|
		1 to: self numberOfRings * 2 do: [:each | tempCanvas frameOval: (Rectangle center: bounds center extent: ringExtent * each) color: ringColor]]"! !

!RadialGraphMorph methodsFor: 'as yet unclassified' stamp: 'len 2/8/2003 00:27'!
ringSeparation
	^ (bounds width min: bounds height) // self numberOfRings! !

!RadialGraphMorph methodsFor: 'as yet unclassified' stamp: 'len 2/9/2003 21:05'!
origin
	^ self center! !

!RadialGraphMorph methodsFor: 'as yet unclassified' stamp: 'len 2/9/2003 21:12'!
cartesianToPolar: aPoint
	| p |
	p _ aPoint - self origin.
	^ p r @ p degrees! !

!GraphLayoutMorph methodsFor: 'private' stamp: ''!
addNode: aGraphNode 
	| morph |
	(nodeToMorph includesKey: aGraphNode)
		ifTrue: [^ nodeToMorph at: aGraphNode].
	morph _ self nodeClass new node: aGraphNode.
	nodeToMorph at: aGraphNode put: morph.
	morph position: (bounds left to: bounds right) atRandom @ (bounds top to: bounds bottom) atRandom.
	self addMorph: morph.
	"(self graph getNode: aGraphNode)"
	aGraphNode
		neighborsAndLabelsDo: [:each :label | 
			self addNode: each.
			self privateAddEdge: aGraphNode -> each label: label].
	^ morph! !

!GraphLayoutMorph methodsFor: 'private' stamp: ''!
removeEdge: anEdge 
	^ self removeEdge: anEdge label: nil! !

GraphLayoutMorph subclass: #SpringsGraphMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Graphs'!

!SpringsGraphMorph methodsFor: 'as yet unclassified' stamp: 'len 2/12/2003 22:26'!
stepTime
	^ 0! !

!SpringsGraphMorph methodsFor: 'as yet unclassified' stamp: 'len 2/18/2003 22:11'!
focusOn: aVertex
	super focusOn: aVertex.
	(nodeToMorph at: aVertex) dxdy: 0@0.
	self startStepping! !

!SpringsGraphMorph methodsFor: 'as yet unclassified' stamp: 'len 2/17/2003 22:53'!
separateAllNodes
	self nodesDo: [:each | each separateFromAllNodes]! !

!SpringsGraphMorph methodsFor: 'as yet unclassified' stamp: 'len 2/8/2003 00:38'!
allowSubmorphExtraction
	" allow extraction so submorphs can be grabbed and dragged to a new position.
	  usefull to rearrange the vertices manually"
	^ true! !

!SpringsGraphMorph methodsFor: 'as yet unclassified' stamp: 'len 2/7/2003 21:15'!
aproachConnectedNodes
	"Connected nodes are tied with a rubber band."
	self edgesDo: [:eachArc | eachArc approachNodes; adjustBounds]! !

!SpringsGraphMorph methodsFor: 'as yet unclassified' stamp: 'len 2/15/2003 18:10'!
edgeClass
	^ SpringEdgeMorph! !

!SpringsGraphMorph methodsFor: 'as yet unclassified' stamp: 'len 2/18/2003 22:07'!
step
	"Calculate a new position for every submorph, based on gravitation law.
	 It's not working as desired, must be changed for some other aproach."
	| maxDelta |
	maxDelta _ 0.
	self nodesDo: [:each | each dxdy: each dxdy / 1.3]. "damping"
	self aproachConnectedNodes; separateAllNodes.
	self nodesDo: [:each |
		each node == focusNode ifFalse: [maxDelta _ maxDelta max: each doMove]].
	self changed.
	maxDelta < 0.5 ifTrue: [self stopStepping]! !

!SpringsGraphMorph methodsFor: 'as yet unclassified' stamp: 'len 2/14/2003 22:54'!
graph: aGraph
	| morph |
	super graph: aGraph.
	(aGraph isKindOf: RootedGraph)
		ifTrue: [morph _ nodeToMorph at: aGraph rootNode.
				morph align: morph center with: self center]! !

!SpringsGraphMorph methodsFor: 'as yet unclassified' stamp: 'len 2/12/2003 23:19'!
nodeClass
	^ SpringsNodeMorph! !

!GraphLayoutMorph methodsFor: 'testing' stamp: 'len 2/12/2003 23:25'!
includesNode: aGraphNode
	^ nodeToMorph includesKey: aGraphNode! !

!GraphLayoutMorph methodsFor: 'layout' stamp: 'Samir Saidani 9/17/2003 18:34'!
redraw
self graph: graph! !

!GraphLayoutMorph methodsFor: 'accessing' stamp: 'len 2/12/2003 23:28'!
origin
	^ (nodeToMorph at: (focusNode ifNil: [^ self center])) center! !

!GraphLayoutMorph methodsFor: 'private' stamp: 'Samir Saidani 6/19/2003 18:04'!
removeEdge: anEdge label: label 
	^ self privateRemoveEdge: anEdge label: label! !

!GraphLayoutMorph methodsFor: 'private' stamp: ''!
privateRemoveEdge: anEdge label: label 
	| edgeArray |
	edgeArray _ Array with: anEdge key with: anEdge value.
	(edgeToMorph includesKey: edgeArray)
		ifFalse: [^ false].
	(edgeToMorph at: edgeArray) delete.
edgeToMorph removeKey: edgeArray.! !

!GraphLayoutMorph methodsFor: 'private' stamp: 'len 2/15/2003 18:11'!
privateAddEdge: anEdge label: label
	| morph edgeArray labelMorph |
	edgeArray _ Array with: anEdge key with: anEdge value.
	(edgeToMorph includesKey: edgeArray) ifTrue: [^ edgeToMorph at: edgeArray].
	morph _ self edgeClass new.
	edgeToMorph at: edgeArray put: morph.
	morph source: (nodeToMorph at: anEdge key); destination: (nodeToMorph at: anEdge value).
	label notNil
		ifTrue: [labelMorph _ label asMorph.
				labelMorph align: labelMorph center with: morph center.
				morph addMorph: labelMorph].
	self addMorphBack: morph.
	^ morph! !

!GraphLayoutMorph methodsFor: 'enumerating' stamp: 'len 2/15/2003 18:58'!
nodesDo: aBlock
	nodeToMorph do: aBlock! !

!GraphLayoutMorph methodsFor: 'layout' stamp: ''!
clearAll

	self clearEdges.
	self clearNodes! !

!GraphLayoutMorph methodsFor: 'private' stamp: 'len 2/12/2003 23:34'!
addEdge: anEdge
	^ self addEdge: anEdge label: nil! !

!GraphLayoutMorph methodsFor: 'accessing' stamp: 'len 2/12/2003 23:28'!
focusOn: aGraphNode
	focusNode _ aGraphNode! !

Morph subclass: #DirectedEdgeMorph
	instanceVariableNames: 'source destination '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Graphs'!

!DirectedEdgeMorph methodsFor: 'accessing' stamp: 'len 8/19/2002 15:04'!
source
	^ source! !

!DirectedEdgeMorph methodsFor: 'private' stamp: 'len 8/26/2002 16:30'!
adjustBounds
	self bounds: (self sourcePoint rect: self destinationPoint)! !

!DirectedEdgeMorph methodsFor: 'accessing' stamp: 'len 8/19/2002 15:05'!
source: aMorph
	source _ aMorph! !

!DirectedEdgeMorph methodsFor: 'accessing' stamp: 'len 8/19/2002 15:03'!
destination
	^ destination! !

!DirectedEdgeMorph methodsFor: 'geometry-testing' stamp: 'len 8/18/2002 03:31'!
containsPoint: aPoint
	^ false! !

!DirectedEdgeMorph methodsFor: 'accessing' stamp: 'len 8/19/2002 15:04'!
destinationPoint
	^ destination center! !

!DirectedEdgeMorph methodsFor: 'accessing' stamp: ''!
destination: aMorph 
	destination _ aMorph.! !

!DirectedEdgeMorph methodsFor: 'accessing' stamp: 'len 8/19/2002 15:05'!
sourcePoint
	^ source center! !

!DirectedEdgeMorph methodsFor: 'initialization' stamp: ''!
initialize
	super initialize.
	self color: Color black.! !

!DirectedEdgeMorph methodsFor: 'drawing' stamp: ''!
drawOn: aCanvas 
	aCanvas
		drawArrowFrom: self sourcePoint
		to: self destinationPoint
		width: 2
		color: self color! !

!DirectedEdgeMorph methodsFor: 'stepping' stamp: 'len 2/18/2003 21:51'!
step
	(source owner isNil or: [destination owner isNil]) ifTrue: [^ self delete].
	self adjustBounds! !

!DirectedEdgeMorph methodsFor: 'stepping' stamp: 'len 2/9/2003 21:52'!
stepTime
	^ 0! !

Morph subclass: #GraphNodeMorph
	instanceVariableNames: 'node '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Graphs'!

!GraphNodeMorph methodsFor: 'drawing' stamp: 'len 2/18/2003 22:03'!
drawOn: aCanvas
"	aCanvas fillOval: self bounds color: self color borderWidth: 1 borderColor: Color black"
	^ self "do nothing!!"! !

GraphNodeMorph subclass: #RadialNodeMorph
	instanceVariableNames: 'startRadius startAngle endRadius endAngle startTime endTime '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Graphs'!

!RadialNodeMorph methodsFor: 'as yet unclassified' stamp: 'len 2/9/2003 21:24'!
step
	| t p |
	startTime isNil ifTrue: [^ self stopStepping].
	t _ Time millisecondClockValue - startTime / (endTime - startTime).
	(t >= 1 or: [t < 0])
		ifTrue: [^ self stopStepping; align: self center with: (owner polarToCartesian: endRadius @ endAngle)].
	t _ (t - 0.5) * 2.
	t _ t arcTan.
	t _ t + 1 / 2.
	p _ startRadius @ startAngle interpolateTo: endRadius @ endAngle at: t.
	self align: bounds center with: (owner polarToCartesian: p).
	self changed! !

!RadialNodeMorph methodsFor: 'as yet unclassified' stamp: 'len 2/14/2003 23:25'!
moveToRadius: radius angle: angle time: msecs
	msecs <= 0 ifTrue: [^ self position: (owner polarToCartesian: radius @ angle)].
	startRadius _ (self center - owner origin) r.
	startAngle _ (self center - owner origin) degrees.
	endRadius _ radius.
	endAngle _ angle + 0.5 \\ 360.
	((endAngle - 360) - startAngle) abs < (endAngle - startAngle) abs
		ifTrue: [endAngle _ endAngle - 360].
	startTime _ Time millisecondClockValue.
	endTime _ startTime + msecs.
	self startStepping! !

!RadialNodeMorph methodsFor: 'as yet unclassified' stamp: 'len 2/8/2003 15:49'!
stepTime
	^ 0! !

!GraphNodeMorph methodsFor: 'accessing' stamp: 'len 2/12/2003 23:20'!
node
	^ node! !

!GraphNodeMorph methodsFor: 'accessing' stamp: 'len 2/18/2003 22:05'!
node: aGraphNode
	| string circle |
	node _ aGraphNode.
	circle _ EllipseMorph new extent: 10@10; color: (Color r: 1.0 g: 0.452 b: 0.065).
	circle align: circle center with: self center.
	self addMorph: circle.
	string _ (StringMorph new contents: aGraphNode value printString).
	string align: string bounds leftCenter with: bounds rightCenter + (4 @ 0 ).
	self addMorph: string! !

!GraphNodeMorph methodsFor: 'initialization' stamp: 'len 2/18/2003 22:02'!
initialize
	super initialize.
	self extent: 10@10! !

GraphNodeMorph subclass: #SpringsNodeMorph
	instanceVariableNames: 'dxdy '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Graphs'!

!SpringsNodeMorph methodsFor: 'moving' stamp: 'len 2/18/2003 21:47'!
nearbyNodesDo3: aBlock
	| count |
	count _ 0.
	node markDo: [:each |
		count _ count + 1.
		count > 40 ifTrue: [^ self].
		aBlock value: (owner nodeToMorph at: each)]! !

!SpringsNodeMorph methodsFor: 'moving' stamp: 'len 2/18/2003 21:58'!
nearbyNodesDo: aBlock
	| count |
	count _ 0.
	node markDo: [:each |
		count _ count + 1.
		count > 40 ifTrue: [^ self].
		aBlock value: (owner nodeToMorph at: each)]! !

!SpringsNodeMorph methodsFor: 'accessing' stamp: 'r++ 12/12/97 03:30'!
dxdy
	^dxdy! !

!SpringsNodeMorph methodsFor: 'moving' stamp: 'len 2/15/2003 18:55'!
aboutToBeGrabbedBy: aHand
	super aboutToBeGrabbedBy: aHand.
	owner focusOn: node! !

!SpringsNodeMorph methodsFor: 'initialization' stamp: 'len 2/14/2003 21:29'!
initialize
	super initialize.
	dxdy _ 0@0! !

!SpringsNodeMorph methodsFor: 'moving' stamp: 'len 2/18/2003 22:00'!
separateFromAllNodes
	| dxdy2 c1 c2 |
	dxdy2 _ 0@0.
	c1 _ self center.
	(owner isKindOf: SpringsGraphMorph) ifFalse: [^ self].
	owner nodesDo: [:each |
		c2 _ each center + each dxdy.
		self == each
			ifFalse: [c1 = c2
						ifTrue: [dxdy2 _ dxdy2 + (3 atRandom - 2 @ (3 atRandom - 2))]
						ifFalse: [dxdy2 _ dxdy2 + ((c1 - c2) / (c1 squaredDistanceTo: c2))]]].
	dxdy2 isZero ifFalse: [self dxdy: self dxdy + (dxdy2 / dxdy2 r * 2)]! !

!SpringsNodeMorph methodsFor: 'as yet unclassified' stamp: 'len 2/18/2003 21:56'!
wantsSteps
	^ false! !

!SpringsNodeMorph methodsFor: 'accessing' stamp: 'len 2/18/2003 21:50'!
step
	self separateFromAllNodes! !

!SpringsNodeMorph methodsFor: 'accessing' stamp: 'len 2/18/2003 21:50'!
stepTime
	^ 0! !

!SpringsNodeMorph methodsFor: 'accessing' stamp: 'len 8/19/2002 01:44'!
dxdy: aPoint
	dxdy _ aPoint! !

!SpringsNodeMorph methodsFor: 'moving' stamp: 'len 2/15/2003 22:42'!
doMove
	self position: self position + dxdy.
"	self privateMoveBy: (bounds amountToTranslateWithin: owner bounds)."
"	self changed."
	^ self dxdy r! !

Morph subclass: #DirectedEdgeMorph2
	instanceVariableNames: 'source destination '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Graphs'!

!DirectedEdgeMorph2 methodsFor: 'accessing' stamp: 'Samir Saidani 6/25/2003 18:30'!
sourcePoint
	^ source center! !

!DirectedEdgeMorph2 methodsFor: 'accessing' stamp: 'Samir Saidani 6/25/2003 18:30'!
source
	^ source! !

!DirectedEdgeMorph2 methodsFor: 'accessing' stamp: 'Samir Saidani 6/25/2003 18:30'!
destination
	^ destination! !

!DirectedEdgeMorph2 methodsFor: 'stepping' stamp: 'Samir Saidani 6/25/2003 18:30'!
stepTime
	^ 0! !

!DirectedEdgeMorph2 methodsFor: 'private' stamp: 'Samir Saidani 6/25/2003 18:30'!
adjustBounds
	self bounds: (self sourcePoint rect: self destinationPoint)! !

!DirectedEdgeMorph2 methodsFor: 'drawing' stamp: 'Samir Saidani 6/25/2003 18:30'!
drawMe
	"| circle string |  
	circle _ EllipseMorph new extent: 20 @ 20;  
	 
	color: (Color  
	r: 1.0  
	g: 0.452  
	b: 0.065).  
	circle align: circle center with: self center.  
	self addMorph: circle.  
	string _ StringMorph new contents: 'test'.  
	string align: string bounds leftCenter with: bounds rightCenter + (4 @  
	0). self addMorph: string"
	| aa |
	aa _ PolygonMorph new.
	aa computeArrowFormAt: self sourcePoint from: self destinationPoint.
	self addMorph: aa! !

!DirectedEdgeMorph2 methodsFor: 'accessing' stamp: 'Samir Saidani 6/25/2003 18:30'!
source: aMorph
	source _ aMorph! !

!DirectedEdgeMorph2 methodsFor: 'drawing' stamp: 'Samir Saidani 6/25/2003 18:30'!
drawOn: aCanvas 
	"frameRectangle: self bounds color: Color black;"
	"aCanvas
		line: self sourcePoint
		to: self destinationPoint
		width: 2
		color: self color"
^self "do nothing !!"! !

!DirectedEdgeMorph2 methodsFor: 'accessing' stamp: 'Samir Saidani 6/25/2003 18:30'!
destinationPoint
	^ destination center! !

!DirectedEdgeMorph2 methodsFor: 'accessing' stamp: 'Samir Saidani 6/25/2003 18:30'!
destination: aMorph 
	destination _ aMorph.
self drawMe.! !

!DirectedEdgeMorph2 methodsFor: 'geometry-testing' stamp: 'Samir Saidani 6/25/2003 18:30'!
containsPoint: aPoint
	^ false! !

!DirectedEdgeMorph2 methodsFor: 'stepping' stamp: 'Samir Saidani 6/25/2003 18:30'!
step
	(source owner isNil or: [destination owner isNil]) ifTrue: [^ self delete].
	self adjustBounds! !

!DirectedEdgeMorph2 methodsFor: 'initialization' stamp: ''!
initialize
	super initialize.! !

Morph subclass: #EdgeMorph
	instanceVariableNames: 'source destination '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Graphs'!

!EdgeMorph methodsFor: 'private' stamp: 'Samir Saidani 6/23/2003 21:17'!
adjustBounds
	self bounds: (self sourcePoint rect: self destinationPoint)! !

!EdgeMorph methodsFor: 'accessing' stamp: 'Samir Saidani 6/23/2003 21:17'!
source: aMorph
	source _ aMorph! !

!EdgeMorph methodsFor: 'geometry-testing' stamp: 'Samir Saidani 6/23/2003 21:17'!
containsPoint: aPoint
	^ false! !

!EdgeMorph methodsFor: 'accessing' stamp: 'Samir Saidani 6/23/2003 21:17'!
destinationPoint
	^ destination center! !

!EdgeMorph methodsFor: 'stepping' stamp: 'Samir Saidani 6/23/2003 21:17'!
step
	(source owner isNil or: [destination owner isNil]) ifTrue: [^ self delete].
	self adjustBounds! !

!EdgeMorph methodsFor: 'accessing' stamp: 'Samir Saidani 6/23/2003 21:17'!
destination: aMorph
	destination _ aMorph! !

EdgeMorph subclass: #SpringEdgeMorph
	instanceVariableNames: 'desiredDistance '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Graphs'!

!SpringEdgeMorph methodsFor: 'as yet unclassified' stamp: 'len 2/17/2003 23:11'!
approachNodes
	"Connected nodes are tied with a rubber band."
	| f currentDistance diff delta |
	(currentDistance _ (diff _ source center + source dxdy - destination center - destination dxdy) r) > desiredDistance
"	(currentDistance _ (diff _ source center - destination center) r) < desiredDistance"
		ifTrue: [f _ (desiredDistance - currentDistance) asFloat / (currentDistance * 4).
				delta _ diff * f / 2.
				destination dxdy: destination dxdy - delta.
				source dxdy: source dxdy + delta]! !

!SpringEdgeMorph methodsFor: 'as yet unclassified' stamp: 'len 2/15/2003 18:07'!
desiredDistance: anInteger
	"Set the distance I want between my vertices."
	desiredDistance _ anInteger! !

!SpringEdgeMorph methodsFor: 'as yet unclassified' stamp: 'len 2/18/2003 21:55'!
step
	(source owner isNil or: [destination owner isNil]) ifTrue: [^ self delete].
"	self approachNodes."
	self adjustBounds! !

!SpringEdgeMorph methodsFor: 'as yet unclassified' stamp: 'len 2/15/2003 18:10'!
initialize
	super initialize.
	desiredDistance _ 50! !

!EdgeMorph methodsFor: 'drawing' stamp: ''!
drawOn: aCanvas 
	"frameRectangle: self bounds color: Color black;"
	aCanvas
		line: self sourcePoint
		to: self destinationPoint
		width: 2
		color: self color! !

!EdgeMorph methodsFor: 'accessing' stamp: 'Samir Saidani 6/23/2003 21:17'!
sourcePoint
	^ source center! !

!EdgeMorph methodsFor: 'stepping' stamp: 'Samir Saidani 6/23/2003 21:17'!
stepTime
	^ 0! !

!EdgeMorph methodsFor: 'accessing' stamp: 'Samir Saidani 6/23/2003 21:17'!
source
	^ source! !

!EdgeMorph methodsFor: 'accessing' stamp: 'Samir Saidani 6/23/2003 21:17'!
destination
	^ destination! !

!EdgeMorph methodsFor: 'initialization' stamp: ''!
initialize
	super initialize.
self color: Color black.! !

!FormCanvas methodsFor: '*graph-drawing-arrow' stamp: ''!
arrowBoundsAt: endPoint from: priorPoint 
	"Stolen in PolygonMorph ;-) : answer a triangle oriented along the line  
	from priorPoint to endPoint."
	| d v angle wingBase arrowSpec length width |
	v _ endPoint - priorPoint.
	angle _ v degrees.
	d _ 1.8.
	arrowSpec _ 5 @ 4.
	length _ arrowSpec x abs.
	width _ arrowSpec y abs.
	wingBase _ endPoint
				+ (Point r: d * length degrees: angle + 180.0).
	arrowSpec x >= 0
		ifTrue: [^ {endPoint. wingBase
				+ (Point r: d * width degrees: angle + 125.0). wingBase
				+ (Point r: d * width degrees: angle - 125.0)}]
		ifFalse: ["Negative length means concave base."
			^ {endPoint. wingBase
				+ (Point r: d * width degrees: angle + 125.0). wingBase. wingBase
				+ (Point r: d * width degrees: angle - 125.0)}]! !

!FormCanvas methodsFor: '*graph-drawing-arrow' stamp: ''!
drawArrowFrom: pt1 to: pt2 width: w color: c 
	| offset |
	offset _ origin - (w // 2) asPoint.
	self setFillColor: c.
	port width: w;
		 height: w;
		 drawFrom: pt1 + offset to: pt2 + offset.
	self
		drawPolygon: (self arrowBoundsAt: pt2 from: pt1)
		color: c
		borderWidth: w
		borderColor: c! !
